package  
{
	import base.Assets;
	import base.Tower;
	import net.flashpunk.graphics.Image;
	import flash.geom.Rectangle;
	import flash.geom.Vector3D;
	import net.flashpunk.Sfx;

	public class AntiAirTower extends Tower 
	{
		private var _sfx:Sfx;
		
		public function AntiAirTower() 
		{
			super();
			
			_range = 2;
			_damage = 5;
			_rateOfFire = 2;
			_sfx = new Sfx(Assets.AntiAirTowerShotSound);
			
			var img:Image = new Image(Assets.AntiAirTowerSpriteSheet, new Rectangle(0, 0, 32, 32));
			graphic = img;
		}
		
		override public function update():void 
		{
			super.update();
			var v:Vector3D 
			var u:Vector3D = new Vector3D(1, 0);
			var angle:Number;

			if (_target != null)
			{
				v = new Vector3D(_target.GetCenter().x - _center.x, _target.GetCenter().y - _center.y);
				v.normalize();
				angle = Math.acos(v.dotProduct(u));
				
				if (angle >=  Math.PI / 4 && angle < 3 * Math.PI / 4 && _target.GetCenter().y > _center.y)
					graphic = new Image(Assets.AntiAirTowerSpriteSheet, new Rectangle(0, (_level - 1) * 32, 32, 32));
				else if (angle >= Math.PI / 4 && angle < 3 * Math.PI / 4)
					graphic = new Image(Assets.AntiAirTowerSpriteSheet, new Rectangle(32, (_level - 1) * 32, 32, 32));
				else if (angle >= 3 * Math.PI / 4 && angle < 5 * Math.PI / 4)
					graphic = new Image(Assets.AntiAirTowerSpriteSheet, new Rectangle(64, (_level - 1) * 32, 32, 32));
				else
					graphic = new Image(Assets.AntiAirTowerSpriteSheet, new Rectangle(96, (_level - 1) * 32, 32, 32));
			}
			
			if (_fired)
			{
				_sfx.play();
				_fired = false;
			}
		}
		
		override public function Upgrade():void 
		{
			super.Upgrade();
			var img:Image = new Image(Assets.AntiAirTowerSpriteSheet, new Rectangle(0, (_level - 1) * 32, 32, 32));
			graphic = img;
		}
		
	}

}