package  
{
	import base.*;
	import flash.geom.Point;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.FP;
	
	import punk.ui.PunkButton;

	public class Level extends GameWorld
	{
		private var _map:Map;
		private var _newTower:Tower;
		private var _towerRadius:TowerRadius;
		private var _towersGrid:Array
		private var _selectedTower:TowerSelection;
		private var _enemies:Array;
		private var _towers:Array;
		private var _enemiesText:EnemiesRemainingText;
		private var _scoreText:ScoreText;
		private var _energyText:EnergyText;
		private var _livesText:LivesText;
		private var _energy:int;
		private var _score:int;
		private var _lives:int;
		private var _enemiesRemaining:int;
		
		private var _YouWin:YouWinPage;
		private var _GameOver:GameOverPage;
		
		private var LevelOneLoaded:Boolean;
		private var LevelTwoLoaded:Boolean;
		private var LevelThreeLoaded:Boolean;
		
		private var LevelsComplete:int;
		
		private var _upgradeButton:PunkButton;		
		private var _sellButton:PunkButton;
		private var _BasicTowerButton:PunkButton;
		private var _AntiAirTowerButton:PunkButton;
		private var _SlowDownTowerButton:PunkButton;
		
		public function Level(score:int) 
		{
			super();
			_score = score;
		}
		
		override public function begin():void 
		{
			var i:int, j:int;

			super.begin();

			_energy = 20;
			_lives = 10;
			_enemiesRemaining = 0;
			
			LevelOneLoaded = false;
			LevelTwoLoaded = false;
			LevelThreeLoaded = false;
			LevelsComplete = 0;
			
			_towersGrid = new Array();
			_towersGrid.length = 15;
			
			_enemies = new Array();
			_towers = new Array();
			
			for (i = 0; i < _towersGrid.length; i++)
			{
				_towersGrid[i] = new Array();
				_towersGrid[i].length = 25;
				for (j = 0; j < _towersGrid[i].length; j++)
					_towersGrid[i][j] = null;
			}
			
			_map = new Map(Library.LoadXML(Assets.Map1));
			add(_map);
			
			addGraphic(new Image(Assets.MenuBackground), -30, 0, 440);
			
			add(_upgradeButton = new PunkButton(210, 500, 120, 31, "Upgrade"));
			_upgradeButton.setCallbacks(UpgradeOnReleased, UpgradeOnPressed, UpgradeOnEnter, UpgradeOnExit);
			_upgradeButton.layer = -100;
			
			add(_sellButton = new PunkButton(210, 550, 120, 31, "Sell"));
			_sellButton.setCallbacks(SellOnReleased, SellOnPressed, SellOnEnter, SellOnExit);
			_sellButton.layer = -100;
			
			add(_BasicTowerButton = new PunkButton(30, 485, 53, 51, "Basic"));
			_BasicTowerButton.setCallbacks(BasicOnReleased, BasicOnPressed, BasicOnEnter, BasicOnExit);
			_BasicTowerButton.layer = -100;
			
			add(_AntiAirTowerButton = new PunkButton(86, 485, 53, 51, "Air"));
			_AntiAirTowerButton.setCallbacks(AntiAirOnReleased, AntiAirOnPressed, AntiAirOnEnter, AntiAirOnExit);
			_AntiAirTowerButton.layer = -100;
			
			add(_SlowDownTowerButton = new PunkButton(142, 485, 53, 51, "Slow"));
			_SlowDownTowerButton.setCallbacks(SlowOnReleased, SlowOnPressed, SlowOnEnter, SlowOnExit);
			_SlowDownTowerButton.layer = -100;
			
			_scoreText = new ScoreText(_score);
			_scoreText.x = 450;
			_scoreText.y = 510;
			_scoreText.layer = -40;
			add(_scoreText);
			
			_energyText = new EnergyText(_energy);
			_energyText.x = 450;
			_energyText.y = 540;
			_energyText.layer = -40;
			add(_energyText);
			
			_livesText = new LivesText(_lives);
			_livesText.x = 625;
			_livesText.y = 510;
			_livesText.layer = -40;
			add(_livesText);
			
			_enemiesText = new EnemiesRemainingText(_enemiesRemaining);
			_enemiesText.x = 625;
			_enemiesText.y = 540;
			_enemiesText.layer = -40;
			add(_enemiesText);
			
			executeWave(Library.LoadXML(Assets.Map1Waves));
			//_addEnemy(1);
			//_addEnemy(2);
			LevelOneLoaded = true;
		}
		
		 public function loadLevel2():void 
		{
			var i:int, j:int;
			
			super.begin();
			
			_energy = 20;
			_lives = 10;
			_enemiesRemaining = 0;
			
			LevelOneLoaded = false;
			LevelTwoLoaded = false;
			LevelThreeLoaded = false;
			
			_towersGrid = new Array();
			_towersGrid.length = 15;			
			_enemies = new Array();
			_towers = new Array();
			
			for (i = 0; i < _towersGrid.length; i++)
			{
				_towersGrid[i] = new Array();
				_towersGrid[i].length = 25;
				for (j = 0; j < _towersGrid[i].length; j++)
					_towersGrid[i][j] = null;
			}			
			_map = new Map(Library.LoadXML(Assets.Map2));
			add(_map);
			
			addGraphic(new Image(Assets.MenuBackground), -30, 0, 440);
			
			add(_upgradeButton = new PunkButton(210, 500, 120, 31, "Upgrade"));
			_upgradeButton.setCallbacks(UpgradeOnReleased, UpgradeOnPressed, UpgradeOnEnter, UpgradeOnExit);
			_upgradeButton.layer = -100;
			
			add(_sellButton = new PunkButton(210, 550, 120, 31, "Sell"));
			_sellButton.setCallbacks(SellOnReleased, SellOnPressed, SellOnEnter, SellOnExit);
			_sellButton.layer = -100;
			
			add(_BasicTowerButton = new PunkButton(30, 485, 53, 51, "Basic"));
			_BasicTowerButton.setCallbacks(BasicOnReleased, BasicOnPressed, BasicOnEnter, BasicOnExit);
			_BasicTowerButton.layer = -100;
			
			add(_AntiAirTowerButton = new PunkButton(86, 485, 53, 51, "Air"));
			_AntiAirTowerButton.setCallbacks(AntiAirOnReleased, AntiAirOnPressed, AntiAirOnEnter, AntiAirOnExit);
			_AntiAirTowerButton.layer = -100;
			
			add(_SlowDownTowerButton = new PunkButton(142, 485, 53, 51, "Slow"));
			_SlowDownTowerButton.setCallbacks(SlowOnReleased, SlowOnPressed, SlowOnEnter, SlowOnExit);
			_SlowDownTowerButton.layer = -100;
			
			_scoreText = new ScoreText(_score);
			_scoreText.x = 450;
			_scoreText.y = 510;
			_scoreText.layer = -40;
			add(_scoreText);
			
			_energyText = new EnergyText(_energy);
			_energyText.x = 450;
			_energyText.y = 540;
			_energyText.layer = -40;
			add(_energyText);
			
			_livesText = new LivesText(_lives);
			_livesText.x = 625;
			_livesText.y = 510;
			_livesText.layer = -40;
			add(_livesText);
			
			_enemiesText = new EnemiesRemainingText(_enemiesRemaining);
			_enemiesText.x = 625;
			_enemiesText.y = 540;
			_enemiesText.layer = -40;
			add(_enemiesText);
			
			executeWave(Library.LoadXML(Assets.Map2Waves));
			
			LevelTwoLoaded = true;
		}
		
		public function loadLevel3():void 
		{
			var i:int, j:int;
			
			super.begin();
			
			_energy = 20;
			_lives = 10;
			_enemiesRemaining = 0;			
			
			LevelOneLoaded = false;
			LevelTwoLoaded = false;
			LevelThreeLoaded = false;
			
			_towersGrid = new Array();
			_towersGrid.length = 15;			
			_enemies = new Array();
			_towers = new Array();
			
			for (i = 0; i < _towersGrid.length; i++)
			{
				_towersGrid[i] = new Array();
				_towersGrid[i].length = 25;
				for (j = 0; j < _towersGrid[i].length; j++)
					_towersGrid[i][j] = null;
			}			
			_map = new Map(Library.LoadXML(Assets.Map3));
			add(_map);
			
			addGraphic(new Image(Assets.MenuBackground), -30, 0, 440);
			
			add(_upgradeButton = new PunkButton(210, 500, 120, 31, "Upgrade"));
			_upgradeButton.setCallbacks(UpgradeOnReleased, UpgradeOnPressed, UpgradeOnEnter, UpgradeOnExit);
			_upgradeButton.layer = -100;
			
			add(_sellButton = new PunkButton(210, 550, 120, 31, "Sell"));
			_sellButton.setCallbacks(SellOnReleased, SellOnPressed, SellOnEnter, SellOnExit);
			_sellButton.layer = -100;
			
			add(_BasicTowerButton = new PunkButton(30, 485, 53, 51, "Basic"));
			_BasicTowerButton.setCallbacks(BasicOnReleased, BasicOnPressed, BasicOnEnter, BasicOnExit);
			_BasicTowerButton.layer = -100;
			
			add(_AntiAirTowerButton = new PunkButton(86, 485, 53, 51, "Air"));
			_AntiAirTowerButton.setCallbacks(AntiAirOnReleased, AntiAirOnPressed, AntiAirOnEnter, AntiAirOnExit);
			_AntiAirTowerButton.layer = -100;
			
			add(_SlowDownTowerButton = new PunkButton(142, 485, 53, 51, "Slow"));
			_SlowDownTowerButton.setCallbacks(SlowOnReleased, SlowOnPressed, SlowOnEnter, SlowOnExit);
			_SlowDownTowerButton.layer = -100;
			
			_scoreText = new ScoreText(_score);
			_scoreText.x = 450;
			_scoreText.y = 510;
			_scoreText.layer = -40;
			add(_scoreText);
			
			_energyText = new EnergyText(_energy);
			_energyText.x = 450;
			_energyText.y = 540;
			_energyText.layer = -40;
			add(_energyText);
			
			_livesText = new LivesText(_lives);
			_livesText.x = 625;
			_livesText.y = 510;
			_livesText.layer = -40;
			add(_livesText);
			
			_enemiesText = new EnemiesRemainingText(_enemiesRemaining);
			_enemiesText.x = 625;
			_enemiesText.y = 540;
			_enemiesText.layer = -40;
			add(_enemiesText);
			
			executeWave(Library.LoadXML(Assets.Map3Waves));
			
			LevelThreeLoaded = true;
		}

		private function _addBasicEnemy(n:int):void
		{
			var e:BasicEnemy = new BasicEnemy();
			e.layer = -30;
			e.x = _map.GetEntryPoint().x * 32 - 32*n;
			e.y = _map.GetEntryPoint().y * 32;
			e.SetDestination(_map.GetNextDestination(0));
			_enemies.push(e);
			add(e);
		}
		
		private function _addFlyingEnemy(n:int):void
		{
			var e:FlyingEnemy = new FlyingEnemy();
			e.layer = -30;
			e.x = _map.GetEntryPoint().x * 32 - 32*n;
			e.y = _map.GetEntryPoint().y * 32;
			e.SetDestination(_map.GetNextDestination(0));
			_enemies.push(e);
			add(e);
		}
		
		public function executeWave(waveData:XML):void
		{
			var i:int;
			var j:int;
			var n:int;
			
			for (i = 0; i < waveData.wave.@rounds; i++)
			{
				for (j = 0; j < waveData.wave.round[i].@num; j++)
				{
					n = (waveData.wave.round[i].@num - j) + (10*i);
					
					if (waveData.wave.round[i].@type == "basic")
					{						
						_addBasicEnemy(n);
						_enemiesRemaining++;
					}
					
					if (waveData.wave.round[i].@type == "flying")
					{						
						_addFlyingEnemy(n);
						_enemiesRemaining++;
					}
				}
			}
		}
		
		override public function update():void 
		{
			super.update();

			var tx:int = int(Input.mouseX / 32);
			var ty:int = int(Input.mouseY / 32);
			
			if (_lives <= 0)
			{
				_GameOver = new GameOverPage();
				FP.world = _GameOver;
			}
			
			if (_enemiesRemaining <= 0 && _lives > 0)
			{
				LevelsComplete++;
			}
			
			if (LevelsComplete == 3)
			{
				_YouWin = new YouWinPage();
				FP.world = _YouWin;
			}
			
			else if (LevelsComplete == 2 && LevelThreeLoaded == false)
			{
				removeAll();
				loadLevel3();
			}
			
			else if (LevelsComplete == 1 && LevelTwoLoaded == false)
			{
				removeAll();
				loadLevel2();
			}
			
			if (Input.mousePressed && _newTower == null && Input.mouseY < 480)
			{
				if (_towersGrid[ty][tx] != null)
				{
					if (_selectedTower != null)
					{
						remove(_selectedTower);
						remove(_towerRadius);
					}
								
					_selectedTower = new TowerSelection(tx, ty);
					add(_selectedTower);
				
					_towerRadius = new TowerRadius(tx * 32 + 15, ty * 32 + 15, _towersGrid[ty][tx].range() * 32);
					_towerRadius.layer = -20;
					add(_towerRadius);
				}
				else if (_selectedTower != null)
				{
					remove(_selectedTower);
					remove(_towerRadius);
				}
			}
			
			if (_newTower != null)
			{
				_newTower.x = tx * 32;
				_newTower.y = ty * 32;
				_towerRadius.x = _newTower.x + 15;
				_towerRadius.y = _newTower.y + 15;
			
				if (Input.mousePressed && Input.mouseY < 448 && _towersGrid[ty][tx] == null && !_map.OnPath(tx, ty))
				{
					Image(_newTower.graphic).alpha = 1;
					_newTower.layer = -20;
					_newTower.x = tx * 32;
					_newTower.y = ty * 32;
					
					if (_newTower.getClass() == BasicTower)
						_energy -= 5;
					else if (_newTower.getClass() == AntiAirTower)
						_energy -= 5;
					else if (_newTower.getClass() == SlowMotionTower)
						_energy -= 10;
					
					_towersGrid[ty][tx] = _newTower;
					_towers.push(_newTower);
					_newTower = null;
					remove(_towerRadius);
				}
			}
			
			for each(var e:Enemy in _enemies)
			{
				if (e.isPassed())
				{
					_enemies.splice(_enemies.indexOf(e), 1);
					remove(e);
					_lives -= 1;
					_enemiesRemaining -= 1;
					continue;
				}
				
				if (!e.isAlive())
				{
					_enemies.splice(_enemies.indexOf(e), 1);
					remove(e);
					_energy += 3;
					_enemiesRemaining -= 1;
					_score += 10;
					continue;
				}
			
				if (e.AtDestination())
				{
					e.SetDestination(_map.GetNextDestination(e.GetCurrentPoint()));
					e.IncrementPoint();
				}
				
				for each(var t:Tower in _towers)
				{
					if (t.getClass() == SlowMotionTower)
						SlowMotionTower(t).SlowTarget(e);
					else
						t.SetTarget(e)
				}
			}
			
			_energyText.UpdateEnergy(_energy);
			_livesText.UpdateLives(_lives);
			_enemiesText.UpdateEnemiesRemaining(_enemiesRemaining);
			_scoreText.UpdateScore(_score);
		}
		
		private function _buildTower(type:Class):void
		{
			var tx:int = int(Input.mouseX / 32) * 32;
			var ty:int = int(Input.mouseY / 32) * 32;
			
			if (_selectedTower  != null)
			{
				remove(_selectedTower);
				remove(_towerRadius);
			}
			
			if (_newTower != null && _newTower.getClass() != type)
			{
				remove(_newTower);
				remove(_towerRadius);
				_newTower = null;
			}
			
			if (_newTower == null)
			{		
				_newTower = new type();
				_newTower.layer = -200;
				Image(_newTower.graphic).alpha = .5;
				_newTower.x = tx * 32;
				_newTower.y = ty * 32;
				add(_newTower);
				
				_towerRadius = new TowerRadius(tx * 32 + 15, ty * 32 + 15, _newTower.range() * 32);
				_towerRadius.layer = -20;
				add(_towerRadius);
			}
		}
		
		//Upgrade Functions
		public function UpgradeOnReleased():void
		{
			var tower:Tower;
			var center:Point;
			
			if (_selectedTower != null)
			{
				tower = _towersGrid[_selectedTower.yTile][_selectedTower.xTile];
				if (_energy >= 3 && (tower.getClass() == BasicTower || tower.getClass() == AntiAirTower))
				{
					tower.Upgrade();
					remove(_towerRadius);
					center = new Point(_towerRadius.x, _towerRadius.y);
					_towerRadius = new TowerRadius(center.x, center.y, tower.range() * 32);
					add(_towerRadius);
					_energy -= 3;
				}
				else if (_energy >= 5 && tower.getClass() == SlowMotionTower)
				{
					tower.Upgrade();
					remove(_towerRadius);
					center = new Point(_towerRadius.x, _towerRadius.y);
					_towerRadius = new TowerRadius(center.x, center.y, tower.range() * 32);
					add(_towerRadius);
					_energy -= 5;
				}
			}
			_upgradeButton.label.text = "Upgrade";
		}
		
		public function UpgradeOnPressed():void
		{
			_upgradeButton.label.text = "Upgrading!";
		}
		
		public function UpgradeOnEnter():void
		{
		}
		
		public function UpgradeOnExit():void
		{
	
		}
		
		
		//Sell Functions
		public function SellOnReleased():void
		{
			var tower:Tower;
			
			if (_selectedTower != null)
			{
				tower = _towersGrid[_selectedTower.yTile][_selectedTower.xTile];
				_energy += tower.GetSaleValue();
				_towers.splice(_towers.indexOf(tower), 1);
				_towersGrid[_selectedTower.yTile][_selectedTower.xTile] = null;
				remove(tower);
				remove(_selectedTower)
				_selectedTower = null;
				remove(_towerRadius);
				_towerRadius = null;
			}		
		}
		
		public function SellOnPressed():void
		{
			_sellButton.label.text = "Selling!";
		}
		
		public function SellOnEnter():void
		{
		}
		
		public function SellOnExit():void
		{
			_sellButton.label.text = "Sell";
		}
		
		
		//Basic Tower Functions
		public function BasicOnReleased():void
		{
			if(_energy >= 5)
				_buildTower(BasicTower);
		}
		
		public function BasicOnPressed():void
		{
			
		}
		
		public function BasicOnEnter():void
		{
		}
		
		public function BasicOnExit():void
		{
		}
		
		
		//Anti-Air Tower Functions
		public function AntiAirOnReleased():void
		{
			if(_energy >= 5)
				_buildTower(AntiAirTower);
		}
		
		public function AntiAirOnPressed():void
		{
		}
		
		public function AntiAirOnEnter():void
		{
		}
		
		public function AntiAirOnExit():void
		{
		}
		
		
		//Slow-Down Tower Functions
		public function SlowOnReleased():void
		{
			if(_energy >= 10)
				_buildTower(SlowMotionTower);
		}
		
		public function SlowOnPressed():void
		{
		}
		
		public function SlowOnEnter():void
		{
		}
		
		public function SlowOnExit():void
		{
		}
		
		override public function end():void 
		{
			super.end();
			removeAll();
		}
	}
}