package  
{
	import base.Assets;
	import base.CompoundEntity;
	import base.GameEntity;
	import flash.geom.Point;
	
	public class Map extends CompoundEntity
	{
		private var _background:Background;
		private var _path:Path;
		private var _grid:MapGrid;
		
		public function Map(mapData:XML)
		{
			var path:Vector.<Point> = new Vector.<Point>();
			var i:int;
			
			//trace(mapData.background);
			//switch(mapData.background)
			//{
				//case "Background1":
					//trace("got here");
		//
					//break;
			//}
			
			for (i = 0; i < mapData.path.@points; i++)
				path.push(new Point(mapData.path.point[i].@x, mapData.path.point[i].@y));
			
			//trace(path);
			//switch(mapData.tileset)
			//{
				//case "PathTileset":
					//_path = new Path(Assets.PathTileset, path);
					//break;
			//}
			
			if (mapData.background == "Background1")
			{
				_background = new Background(Assets.Background1);
				_background.layer = 0;
				AddEntity(_background);
			}
			
			else if (mapData.background == "Background2")
			{
				_background = new Background(Assets.Background2);
				_background.layer = 0;
				AddEntity(_background);
			}
			
			else if (mapData.background == "Background3")
			{
				_background = new Background(Assets.Background3);
				_background.layer = 0;
				AddEntity(_background);
			}
			
			_grid = new MapGrid();
			_grid.layer = -10;
			AddEntity(_grid);
			
			if (mapData.tileset == "MoonTileset")
			{
				_path = new Path(Assets.MoonTileset, path);
				_path.layer = -20;
				AddEntity(_path);
			}
			
			else if (mapData.tileset == "PathTileset")
			{
				_path = new Path(Assets.PathTileset, path);
				_path.layer = -20;
				AddEntity(_path);
			}
			
			else if (mapData.tileset == "RoadTileset")
			{
				_path = new Path(Assets.RoadTileset, path);
				_path.layer = -20;
				AddEntity(_path);
			}
		}
		
		public function OnPath(xTile:int, yTile:int):Boolean
		{
			return _path.OnPath(xTile, yTile);
		}
		
		public function GetNextDestination(current:int):Point
		{
			return _path.GetNextDestination(current);
		}
		
		public function GetEntryPoint():Point
		{
			return _path.GetEntryPoint();
		}
	}
}