package  
{
	import base.Assets;
	import base.Library;
	import base.Enemy;
	import base.Tower;
	import net.flashpunk.graphics.Image;
	import flash.geom.Rectangle;

	public class SlowMotionTower extends Tower 
	{
		private var _slowPercent:Number;
		
		public function SlowMotionTower() 
		{
			super();
			_range = 3;
			_slowPercent = .5;
			
			var img:Image = new Image(Assets.SlowMotionTowerSpriteSheet, new Rectangle(0, 0, 32, 32));
			graphic = img;
		}	
		
		public function SlowTarget(e:Enemy):void
		{
			if (Library.Distance(_center, e.GetCenter()) < _range * 32)
				e.SlowTarget(_slowPercent);
			else
				e.UnSlowTarget();
		}
		
		override public function Upgrade():void 
		{
			super.Upgrade();
			var img:Image = new Image(Assets.SlowMotionTowerSpriteSheet, new Rectangle(0, (_level - 1) * 32, 32, 32));
			graphic = img;
			_cost += 5;
			_slowPercent *= 1.15;
		}
	}

}