package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.World;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.graphics.Image;
	import punk.ui.PunkButton;
	import base.*;
	
	public class StartPage extends World
	{
		private var _gameWorld:GameWorld;
		public var _menuBackground:Image = new Image(Assets.TitleImage);
		private var _story:StoryPage;
		private var _creditsPage:CreditsPage;
		
		private var _creditsButton:PunkButton;
		private var _startGameButton:PunkButton;
		
		public function StartPage() 
		{
			super();
		}
		
		override public function begin():void 
		{
			super.begin();
			
			add(_startGameButton = new PunkButton(300, 400, 200, 50, "Start Game"));
			_startGameButton.setCallbacks(StartOnReleased, StartOnPressed, StartOnEnter, StartOnExit);
			_startGameButton.layer = -100;
			
			add(_creditsButton = new PunkButton(300, 470, 200, 50, "Credits"));
			_creditsButton.setCallbacks(CreditsOnReleased, CreditsOnPressed, CreditsOnEnter, CreditsOnExit);
			_creditsButton.layer = -100;
			
			addGraphic(_menuBackground);
		}
			
		override public function end():void 
		{
			super.end();
			removeAll();
		}
		
		override public function update():void
		{
			super.update();
		}
		
		//Start Game Functions
		public function StartOnReleased():void{}
		
		public function StartOnPressed():void
		{
				_story = new StoryPage();
				FP.world = _story;
		}
		
		public function StartOnEnter():void{}
		
		public function StartOnExit():void{}
		
		
		//Credits Functions
		public function CreditsOnReleased():void{}
		
		public function CreditsOnPressed():void
		{
			_creditsPage = new CreditsPage();
			FP.world = _creditsPage;
		}
		
		public function CreditsOnEnter():void{}
		
		public function CreditsOnExit():void{}
	}
}