package base 
{
	import flash.geom.Point;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Spritemap;
	
	public class Enemy extends GameEntity 
	{
		protected var _hitPoints:int;
		protected var _baseSpeed:Number;
		protected var _speed:Number;
		public var _id:int;
		protected static var _count:int = 0;
		protected var _destination:Point;
		protected var _currentPoint:int;
		protected var _alive:Boolean;
		protected var _slowed:Boolean;
		protected var _passed:Boolean;
		
		public function Enemy() 
		{
			_id = _count;
			_count++;
			_currentPoint = 0;
			_center = new Point(0, 0);
			_alive = true;
			_slowed = false;
			_passed = false;
		}
		
		public function TakeDamage(dmg:int):void 
		{
			_hitPoints -= dmg;
			if (_hitPoints <= 0)
				_alive = false;
			else
				_alive = true;
		}
		
		public function SetDestination(destination:Point):void
		{
			_destination = destination;
		}
		
		public function AtDestination():Boolean
		{
			if (x == _destination.x * 32 && y == _destination.y * 32)
				return true;
			else
				return false;
		}
		
		public function GetCurrentPoint():int
		{
			return _currentPoint;
		}
		
		public function IncrementPoint():void
		{
			_currentPoint++;
		}
		
		public function GetCenter():Point
		{
			return _center;
		}
		
		override public function removed():void 
		{
			super.removed();
			_count--;
		}
		
		override public function update():void 
		{
			super.update();
			_center.x = x + 15;
			_center.y = y + 15;
			if (_destination != null)
			{
				if (_destination.x == -1 && _destination.y == -1)
				{
					if (x > 800)
						_passed = true;
					else
						moveTowards(x + 32, y, _speed * FP.elapsed);
				}
				else
					moveTowards(_destination.x * 32, _destination.y * 32, _speed * FP.elapsed);
			}	
		}
		
		public function isAlive():Boolean
		{
			return _alive;
		}
		
		public function isSlowed():Boolean
		{
			return _slowed;
		}
		
		public function SlowTarget(sp:Number):void
		{
			if (!_slowed || _baseSpeed * (1 - sp) < _speed)
			{
				
				_speed = _speed * (1 - sp);
				_slowed = true;
				trace(_speed);
			}
		}
		
		public function UnSlowTarget():void
		{
			_speed = _baseSpeed;
		}
		
		public function isPassed():Boolean
		{
			return _passed;
		}
	}

}