package base 
{
	import base.GameEntity;
	import flash.geom.Point;
	import net.flashpunk.FP;

	public class Tower extends GameEntity 
	{
		protected var _level:int;
		protected var _cost:int;
		protected var _range:Number;
		protected var _target:Enemy;
		protected var _damage:Number;
		protected var _rateOfFire:int;
		protected var _fired:Boolean;
		
		protected var _elapsed:Number;
		
		public function Tower() 
		{
			_level = 1;
			_target = null;
			_center = new Point(0, 0);
			_elapsed = 0;
		}	
		
		public function SetTarget(e:Enemy):void
		{
			if (_target == null && Library.Distance(_center, e.GetCenter()) < _range * 32)
			{
				if ((e.getClass() == BasicEnemy && this.getClass() == BasicTower) ||
					(e.getClass() == FlyingEnemy && this.getClass() == AntiAirTower))
					_target = e;
			
			}
		}
		override public function update():void 
		{
			super.update();
			_elapsed += FP.elapsed;
			_center.x = x + 15;
			_center.y = y + 15;

			if (_target != null)
			{		
				if (Library.Distance(_target.GetCenter(), _center) > _range * 32)
					_target = null;
				else if (_elapsed > _rateOfFire)
				{
					_elapsed = 0;
					_fired = true;
					_target.TakeDamage(_damage);
					if(!_target.isAlive())
						_target = null;	
				}
			}

		}
		public function range():Number
		{
			return _range;
		}
		
		public function GetLevel():int
		{
			return _level;
		}
		
		public function Upgrade():void
		{
			if (_level < 3)
			{
				_level++;
				_range = _range * 1.2;
				_damage = _damage * 1.2;
			}
		}
		
		public function GetSaleValue():int
		{
			return _cost * .75;
		}
	}
}